/*
 * rob_late.c
 *
 * Created: 19.03.2023 11:39:59
 *  Author: may21
 */ 


#include <avr/io.h>


#include <avr/io.h>
#define F_CPU 8000000UL // 8 
#include <util/delay.h> // 
#include <avr/interrupt.h>//   


void preset () //    
{
	DDRD=0x00; //    
	PORTD=0x00; //       
	DDRC=0b1011111; //       PC5
	PORTC=0x00; //     0
	DDRB=0xFF; //     
	PORTB=0x00;  //     0
}
#define START 0 //
#define STOP 1  //

volatile unsigned int distance = 12180; // .
volatile unsigned char status = START;


ISR(INT0_vect) //       INT0
{
	if(PIND & (1 << PIND2)) //          
	{
		TCNT1 = 0x00;
		status = START;
	}
	else //   ,   .         
	{
		distance = TCNT1;
		status = STOP;
	}
}

void tango ()
{
	  OCR2=50;// 
	  int i;
	  for (i=1; i<=3;i++)
	  {
	PORTC=0b0000100;  //  
	  _delay_ms(400);
	 PORTC &= ~(1<<2); //  
	 _delay_ms(100); //  
	PORTC=0b0000010; //  
	  _delay_ms(400);
	  PORTC &= ~(1<<1); //  
	 _delay_ms(100); //   
	PORTC=0b0010000;//  
	  _delay_ms(400);
	  PORTC &= ~(1<<4); //  
	  _delay_ms(100); //   
	PORTC=0b0001000;//   
	   _delay_ms(400);
	  PORTC &= ~(1<<3); //   
	 _delay_ms(100); //    
	}
}

void sonic1 ()
{
	PORTB |= (1 << 0);  //  
	_delay_us(20);           //    ,
	PORTB &= ~(1 << 0); //    20  
	PORTC=0x00; // 
	_delay_ms(100);

	if(status) //  .   ,   ,   
	{
		int n=0;
		n=distance/58;
			status = START; //       
			_delay_ms(100); // 
		if ((n<150)&&(n>=60))//    150      60 
		{
			OCR2=50;// 
			PORTC=0b0010100; //     
			_delay_ms(500);
			PORTC=0x00; // 
			_delay_ms(100);
		}	
		else
		{
			PORTC=0x00; // 
			_delay_ms(100);
		}
		if (n<40)//    40 
		{
			OCR2=50;// 
			PORTC=0b0001010; //     
			_delay_ms(500);
			PORTC=0x00; // 
			_delay_ms(100);
		}
		else
		{
			PORTC=0x00; // 
			_delay_ms(100);
			
		}
		if ((n<60)&&(n>=40))//    60      40 
		{
			 tango();
		}
		
	}
}

int main(void)
{
	preset();
	
	//    1  (     )
	TCCR1A = 0x00;//    
	TCCR1B |= (1 << CS11);//  8
	TCNT1H = 0x00;
	TCNT1L = 0x00;
	
	  GICR |= (1<<INT0); //    int0
	//  GICR |= (1<<INT1); //    int1  
	  MCUCR |= (0<<ISC01)|(1<<ISC00);//|(1<<ISC11)|(0<<ISC10);//  INTO   , INT1  
	sei();//   
	char in = 1;   //   in      1
    while(1)
	{

		if (!(PIND & (1<<PIND5)) && in == 1 )//   PD5      in   = 1,      
		{
			in = 0;    // 1.        

			_delay_ms(20);    // 2.  20.  -    
		 TCCR2=0b01101110;//   
		 OCR2=10;// 
		 sonic1();
		// mig();		
		}

		if (PIND & (1 << PIND5) && in == 0)    /*  PD5     in = 0,
	      , . .   0  1 */
		{
		in = 1;    //         
		_delay_ms(20);    /*  20 -    ,
		         */
		}
		}
	
		}